blob: 8c7cacdae31b3f4437556205665a1e6f167323fb [file] [log] [blame]
Benedikt Böhm00ccea62010-01-26 12:39:36 +01001#
Vincent Driessen6c2d30b2010-01-26 22:18:36 +01002# git-flow -- A collection of Git extensions to provide high-level
3# repository operations for Vincent Driessen's branching model.
Benedikt Böhm00ccea62010-01-26 12:39:36 +01004#
5# Original blog post presenting this model is found at:
Vincent Driessenddb350b2010-07-09 09:42:09 +02006# http://nvie.com/git-model
Benedikt Böhm00ccea62010-01-26 12:39:36 +01007#
8# Feel free to contribute to this project at:
9# http://github.com/nvie/gitflow
10#
Vincent Driessend72acba2010-04-04 16:10:17 +020011# Copyright 2010 Vincent Driessen. All rights reserved.
12#
13# Redistribution and use in source and binary forms, with or without
14# modification, are permitted provided that the following conditions are met:
15#
16# 1. Redistributions of source code must retain the above copyright notice,
17# this list of conditions and the following disclaimer.
18#
19# 2. Redistributions in binary form must reproduce the above copyright
20# notice, this list of conditions and the following disclaimer in the
21# documentation and/or other materials provided with the distribution.
22#
23# THIS SOFTWARE IS PROVIDED BY VINCENT DRIESSEN ``AS IS'' AND ANY EXPRESS OR
24# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
25# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
26# EVENT SHALL VINCENT DRIESSEN OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
27# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
28# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
29# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
30# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
31# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
32# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
33#
34# The views and conclusions contained in the software and documentation are
35# those of the authors and should not be interpreted as representing official
36# policies, either expressed or implied, of Vincent Driessen.
Benedikt Böhm00ccea62010-01-26 12:39:36 +010037#
38
Vincent Driessen7832d6e2010-02-21 21:31:03 +010039require_git_repo
40require_gitflow_initialized
Vincent Driessend72e4ac2010-02-16 21:33:51 +010041gitflow_load_settings
Vincent Driessenc1598bf2010-02-20 16:52:48 +010042PREFIX=$(git config --get gitflow.prefix.feature)
Benedikt Böhm49dd62b2010-01-28 00:51:15 +010043
Benedikt Böhm00ccea62010-01-26 12:39:36 +010044usage() {
Vincent Driessenb03cf962010-02-01 22:00:39 +010045 echo "usage: git flow feature [list] [-v]"
Vincent Driessen2b829ce2010-07-09 09:36:20 +020046 echo " git flow feature start [-F] <name> [<base>]"
Vincent Driessena2e41162010-02-24 01:37:07 +010047 echo " git flow feature finish [-rF] <name|nameprefix>"
Vincent Driessen186d2b52010-01-27 23:48:39 +010048 echo " git flow feature publish <name>"
49 echo " git flow feature track <name>"
Vincent Driessena2e41162010-02-24 01:37:07 +010050 echo " git flow feature diff [<name|nameprefix>]"
51 echo " git flow feature rebase [-i] [<name|nameprefix>]"
Vincent Driessend43ab842010-05-27 11:26:01 -070052 echo " git flow feature checkout [<name|nameprefix>]"
Vincent Driessenf68d4052010-07-09 12:34:18 +020053 echo " git flow feature pull <remote> [<name>]"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010054}
55
Vincent Driessen186d2b52010-01-27 23:48:39 +010056cmd_default() {
Vincent Driessenb866b012010-01-28 01:01:53 +010057 cmd_list "$@"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010058}
59
Vincent Driessenb866b012010-01-28 01:01:53 +010060cmd_list() {
Vincent Driessen44174922010-02-02 23:53:21 +010061 DEFINE_boolean verbose false 'verbose (more) output' v
Vincent Driessen1b819232010-02-01 15:51:43 +010062 parse_args "$@"
63
Vincent Driessenf46e2902010-02-15 23:01:52 +010064 local feature_branches
65 local current_branch
66 local short_names
Vincent Driessen7832d6e2010-02-21 21:31:03 +010067 feature_branches=$(echo "$(git_local_branches)" | grep "^$PREFIX")
Vincent Driessen27592dd2010-02-06 14:45:39 +010068 if [ -z "$feature_branches" ]; then
Vincent Driessen186d2b52010-01-27 23:48:39 +010069 warn "No feature branches exist."
Randy Merrillb681b452010-06-26 13:14:15 +080070 warn ""
71 warn "You can start a new feature branch:"
72 warn ""
73 warn " git flow feature start <name> [<base>]"
Randy Merrill4de01f22010-06-26 13:19:06 +080074 warn ""
Vincent Driessen186d2b52010-01-27 23:48:39 +010075 exit 0
76 fi
Adam Gibbinscf3da5a2010-08-22 19:13:34 +010077 current_branch=$(git branch --no-color | grep '^\* ' | grep -v 'no branch' | sed 's/^* //g')
Vincent Driessen27592dd2010-02-06 14:45:39 +010078 short_names=$(echo "$feature_branches" | sed "s ^$PREFIX g")
Vincent Driessenf2536f42010-02-01 15:57:48 +010079
Vincent Driessenaa6d0162010-02-01 19:43:46 +010080 # determine column width first
Vincent Driessenf46e2902010-02-15 23:01:52 +010081 local width=0
82 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010083 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010084 local len=${#branch}
Vincent Driessenaa6d0162010-02-01 19:43:46 +010085 width=$(max $width $len)
86 done
Vincent Driessenf46e2902010-02-15 23:01:52 +010087 width=$(($width+3))
Vincent Driessen1adbc3e2010-01-30 16:28:20 +010088
Vincent Driessenf46e2902010-02-15 23:01:52 +010089 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010090 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010091 local fullname=$PREFIX$branch
92 local base=$(git merge-base "$fullname" "$DEVELOP_BRANCH")
93 local develop_sha=$(git rev-parse "$DEVELOP_BRANCH")
94 local branch_sha=$(git rev-parse "$fullname")
Vincent Driessen27592dd2010-02-06 14:45:39 +010095 if [ "$fullname" = "$current_branch" ]; then
Vincent Driessenaa6d0162010-02-01 19:43:46 +010096 printf "* "
97 else
98 printf " "
99 fi
Vincent Driessen44174922010-02-02 23:53:21 +0100100 if flag verbose; then
Vincent Driessen1adbc3e2010-01-30 16:28:20 +0100101 printf "%-${width}s" "$branch"
Vincent Driessenf2536f42010-02-01 15:57:48 +0100102 if [ "$branch_sha" = "$develop_sha" ]; then
103 printf "(no commits yet)"
104 elif [ "$base" = "$branch_sha" ]; then
105 printf "(is behind develop, may ff)"
106 elif [ "$base" = "$develop_sha" ]; then
107 printf "(based on latest develop)"
108 else
109 printf "(may be rebased)"
110 fi
Vincent Driessenaa6d0162010-02-01 19:43:46 +0100111 else
112 printf "%s" "$branch"
113 fi
114 echo
115 done
Vincent Driessen186d2b52010-01-27 23:48:39 +0100116}
117
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100118cmd_help() {
119 usage
120 exit 0
121}
122
Vincent Driessend0991262010-02-06 21:19:07 +0100123require_name_arg() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100124 if [ "$NAME" = "" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100125 warn "Missing argument <name>"
Vincent Driessen1b819232010-02-01 15:51:43 +0100126 usage
Vincent Driessen2e1856b2010-01-29 15:18:13 +0100127 exit 1
128 fi
129}
130
Vincent Driessend0991262010-02-06 21:19:07 +0100131expand_nameprefix_arg() {
132 require_name_arg
133
Vincent Driessenf46e2902010-02-15 23:01:52 +0100134 local expanded_name
135 local exitcode
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100136 expanded_name=$(gitflow_resolve_nameprefix "$NAME" "$PREFIX")
Vincent Driessend0991262010-02-06 21:19:07 +0100137 exitcode=$?
138 case $exitcode in
139 0) NAME=$expanded_name
140 BRANCH=$PREFIX$NAME
141 ;;
142 *) exit 1 ;;
143 esac
Vincent Driessen2e1856b2010-01-29 15:18:13 +0100144}
145
Vincent Driessenf68d4052010-07-09 12:34:18 +0200146use_current_feature_branch_name() {
147 local current_branch=$(git_current_branch)
148 if startswith "$current_branch" "$PREFIX"; then
149 BRANCH=$current_branch
150 NAME=${BRANCH#$PREFIX}
151 else
152 warn "The current HEAD is no feature branch."
153 warn "Please specify a <name> argument."
154 exit 1
155 fi
156}
157
Vincent Driessend0991262010-02-06 21:19:07 +0100158expand_nameprefix_arg_or_current() {
Vincent Driessenc62633f2010-02-02 10:48:50 +0100159 if [ "$NAME" != "" ]; then
Vincent Driessend0991262010-02-06 21:19:07 +0100160 expand_nameprefix_arg
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100161 require_branch "$PREFIX$NAME"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100162 else
Vincent Driessenf68d4052010-07-09 12:34:18 +0200163 use_current_feature_branch_name
Vincent Driessenc62633f2010-02-02 10:48:50 +0100164 fi
165}
166
Vincent Driessenf68d4052010-07-09 12:34:18 +0200167name_or_current() {
168 if [ -z "$NAME" ]; then
169 use_current_feature_branch_name
170 fi
171}
172
173parse_cmdline() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100174 # parse options
175 FLAGS "$@" || exit $?
176 eval set -- "${FLAGS_ARGV}"
Vincent Driessenf68d4052010-07-09 12:34:18 +0200177}
178
179parse_args() {
180 parse_cmdline "$@"
Vincent Driessen1b819232010-02-01 15:51:43 +0100181
182 # read arguments into global variables
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100183 NAME=$1
Vincent Driessen11560922010-02-01 21:58:37 +0100184 BRANCH=$PREFIX$NAME
Vincent Driessenb866b012010-01-28 01:01:53 +0100185}
186
Vincent Driessenf68d4052010-07-09 12:34:18 +0200187parse_remote_name() {
188 parse_cmdline "$@"
189
190 # read arguments into global variables
191 REMOTE=$1
192 NAME=$2
193 BRANCH=$PREFIX$NAME
194}
195
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100196cmd_start() {
Vincent Driessen44174922010-02-02 23:53:21 +0100197 DEFINE_boolean fetch false 'fetch from origin before performing local operation' F
Vincent Driessenea608952010-01-29 16:56:29 +0100198 parse_args "$@"
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100199 BASE=${2:-$DEVELOP_BRANCH}
Vincent Driessend0991262010-02-06 21:19:07 +0100200 require_name_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100201
202 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100203 require_branch_absent "$BRANCH"
Vincent Driessene034e4a2010-01-29 12:10:44 +0100204
205 # update the local repo with remote changes, if asked
Vincent Driessen44174922010-02-02 23:53:21 +0100206 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100207 git fetch -q "$ORIGIN" "$DEVELOP_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100208 fi
209
Vincent Driessenc118a852010-04-04 16:32:04 +0200210 # if the origin branch counterpart exists, assert that the local branch
211 # isn't behind it (to avoid unnecessary rebasing)
212 if git_branch_exists "$ORIGIN/$DEVELOP_BRANCH"; then
213 require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
214 fi
Vincent Driessene034e4a2010-01-29 12:10:44 +0100215
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100216 # create branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100217 if ! git checkout -b "$BRANCH" "$BASE"; then
Vincent Driessen5455a6f2010-02-03 00:14:05 +0100218 die "Could not create feature branch '$BRANCH'"
219 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100220
221 echo
222 echo "Summary of actions:"
223 echo "- A new branch '$BRANCH' was created, based on '$BASE'"
224 echo "- You are now on branch '$BRANCH'"
225 echo ""
226 echo "Now, start committing on your feature. When done, use:"
227 echo ""
gmallard192ff522010-04-01 19:31:09 -0400228 echo " git flow feature finish $NAME"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100229 echo
230}
231
232cmd_finish() {
Vincent Driessenca73caf2010-02-07 19:46:38 +0100233 DEFINE_boolean fetch false "fetch from $ORIGIN before performing finish" F
Vincent Driessen44174922010-02-02 23:53:21 +0100234 DEFINE_boolean rebase false 'rebase instead of merge' r
Vincent Driessen1b819232010-02-01 15:51:43 +0100235 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100236 expand_nameprefix_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100237
238 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100239 require_branch "$BRANCH"
Vincent Driessene034e4a2010-01-29 12:10:44 +0100240
Vincent Driessen49c7d022010-01-28 12:40:33 +0100241 # detect if we're restoring from a merge conflict
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100242 if [ -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE" ]; then
Vincent Driessen49c7d022010-01-28 12:40:33 +0100243 #
244 # TODO: detect that we're working on the correct branch here!
245 # The user need not necessarily have given the same $NAME twice here
246 # (although he/she should).
247 #
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100248
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100249 # TODO: git_is_clean_working_tree() should provide an alternative
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100250 # exit code for "unmerged changes in working tree", which we should
251 # actually be testing for here
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100252 if git_is_clean_working_tree; then
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100253 FINISH_BASE=$(cat "$DOT_GIT_DIR/.gitflow/MERGE_BASE")
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100254
255 # Since the working tree is now clean, either the user did a
256 # succesfull merge manually, or the merge was cancelled.
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100257 # We detect this using git_is_branch_merged_into()
258 if git_is_branch_merged_into "$BRANCH" "$FINISH_BASE"; then
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100259 rm -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100260 helper_finish_cleanup
261 exit 0
262 else
263 # If the user cancelled the merge and decided to wait until later,
264 # that's fine. But we have to acknowledge this by removing the
265 # MERGE_BASE file and continuing normal execution of the finish
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100266 rm -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100267 fi
Vincent Driessen49c7d022010-01-28 12:40:33 +0100268 else
269 echo
270 echo "Merge conflicts not resolved yet, use:"
271 echo " git mergetool"
272 echo " git commit"
273 echo
274 echo "You can then complete the finish by running it again:"
275 echo " git flow feature finish $NAME"
276 echo
277 exit 1
278 fi
279 fi
280
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100281 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100282 require_clean_working_tree
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100283
Vincent Driessene034e4a2010-01-29 12:10:44 +0100284 # update local repo with remote changes first, if asked
Mark Derricutt8a86c482010-07-20 21:11:48 +1200285 if has "$ORIGIN/$BRANCH" "$(git_remote_branches)"; then
Vincent Driessencb654b12010-07-21 13:28:54 +0200286 if flag fetch; then
287 git fetch -q "$ORIGIN" "$BRANCH"
288 fi
Vincent Driessene034e4a2010-01-29 12:10:44 +0100289 fi
290
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100291 if has "$ORIGIN/$BRANCH" "$(git_remote_branches)"; then
292 require_branches_equal "$BRANCH" "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100293 fi
Mark Derricutt8a86c482010-07-20 21:11:48 +1200294 if has "$ORIGIN/$DEVELOP_BRANCH" "$(git_remote_branches)"; then
Vincent Driessencb654b12010-07-21 13:28:54 +0200295 require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
296 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100297
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100298 # if the user wants to rebase, do that first
Vincent Driessen44174922010-02-02 23:53:21 +0100299 if flag rebase; then
Vincent Driessen010252a2010-02-04 10:31:29 +0100300 if ! git flow feature rebase "$NAME" "$DEVELOP_BRANCH"; then
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100301 warn "Finish was aborted due to conflicts during rebase."
302 warn "Please finish the rebase manually now."
303 warn "When finished, re-run:"
Vincent Driessen010252a2010-02-04 10:31:29 +0100304 warn " git flow feature finish '$NAME' '$DEVELOP_BRANCH'"
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100305 exit 1
306 fi
307 fi
308
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100309 # merge into BASE
Vincent Driessena4dd2232010-02-10 00:34:59 +0100310 git checkout "$DEVELOP_BRANCH"
311 if [ "$(git rev-list -n2 "$DEVELOP_BRANCH..$BRANCH" | wc -l)" -eq 1 ]; then
312 git merge --ff "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100313 else
Vincent Driessena4dd2232010-02-10 00:34:59 +0100314 git merge --no-ff "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100315 fi
316
Vincent Driessen49c7d022010-01-28 12:40:33 +0100317 if [ $? -ne 0 ]; then
318 # oops.. we have a merge conflict!
Vincent Driessen010252a2010-02-04 10:31:29 +0100319 # write the given $DEVELOP_BRANCH to a temporary file (we need it later)
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100320 mkdir -p "$DOT_GIT_DIR/.gitflow"
321 echo "$DEVELOP_BRANCH" > "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessen49c7d022010-01-28 12:40:33 +0100322 echo
323 echo "There were merge conflicts. To resolve the merge conflict manually, use:"
324 echo " git mergetool"
325 echo " git commit"
326 echo
327 echo "You can then complete the finish by running it again:"
328 echo " git flow feature finish $NAME"
329 echo
330 exit 1
331 fi
332
333 # when no merge conflict is detected, just clean up the feature branch
334 helper_finish_cleanup
335}
336
337helper_finish_cleanup() {
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100338 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100339 require_branch "$BRANCH"
340 require_clean_working_tree
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100341
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100342 # delete branch
Vincent Driessen44174922010-02-02 23:53:21 +0100343 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100344 git push "$ORIGIN" ":refs/heads/$BRANCH"
Vincent Driesseneec73c62010-02-02 16:14:16 +0100345 fi
Vincent Driessene761e352010-07-08 14:41:14 +0200346 git branch -D "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100347
348 echo
349 echo "Summary of actions:"
Vincent Driessen010252a2010-02-04 10:31:29 +0100350 echo "- The feature branch '$BRANCH' was merged into '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100351 #echo "- Merge conflicts were resolved" # TODO: Add this line when it's supported
352 echo "- Feature branch '$BRANCH' has been removed"
Vincent Driessen010252a2010-02-04 10:31:29 +0100353 echo "- You are now on branch '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100354 echo
355}
356
357cmd_publish() {
Vincent Driessenea608952010-01-29 16:56:29 +0100358 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100359 expand_nameprefix_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100360
361 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100362 require_clean_working_tree
363 require_branch "$BRANCH"
Vincent Driessena4dd2232010-02-10 00:34:59 +0100364 git fetch -q "$ORIGIN"
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100365 require_branch_absent "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100366
367 # create remote branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100368 git push "$ORIGIN" "$BRANCH:refs/heads/$BRANCH"
369 git fetch -q "$ORIGIN"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100370
371 # configure remote tracking
Vincent Driessena4dd2232010-02-10 00:34:59 +0100372 git config "branch.$BRANCH.remote" "$ORIGIN"
373 git config "branch.$BRANCH.merge" "refs/heads/$BRANCH"
374 git checkout "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100375
376 echo
377 echo "Summary of actions:"
378 echo "- A new remote branch '$BRANCH' was created"
379 echo "- The local branch '$BRANCH' was configured to track the remote branch"
380 echo "- You are now on branch '$BRANCH'"
381 echo
382}
383
384cmd_track() {
Vincent Driessenea608952010-01-29 16:56:29 +0100385 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100386 require_name_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100387
388 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100389 require_clean_working_tree
390 require_branch_absent "$BRANCH"
Vincent Driessena4dd2232010-02-10 00:34:59 +0100391 git fetch -q "$ORIGIN"
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100392 require_branch "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100393
394 # create tracking branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100395 git checkout -b "$BRANCH" "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100396
397 echo
398 echo "Summary of actions:"
399 echo "- A new remote tracking branch '$BRANCH' was created"
400 echo "- You are now on branch '$BRANCH'"
401 echo
402}
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100403
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100404cmd_diff() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100405 parse_args "$@"
Vincent Driessen1b819232010-02-01 15:51:43 +0100406
Vincent Driessen5474e462010-02-04 15:50:06 +0100407 if [ "$NAME" != "" ]; then
Vincent Driessend0991262010-02-06 21:19:07 +0100408 expand_nameprefix_arg
Vincent Driessena4dd2232010-02-10 00:34:59 +0100409 BASE=$(git merge-base "$DEVELOP_BRANCH" "$BRANCH")
410 git diff "$BASE..$BRANCH"
Vincent Driessen5474e462010-02-04 15:50:06 +0100411 else
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100412 if ! git_current_branch | grep -q "^$PREFIX"; then
Vincent Driessen5474e462010-02-04 15:50:06 +0100413 die "Not on a feature branch. Name one explicitly."
414 fi
415
Vincent Driessena4dd2232010-02-10 00:34:59 +0100416 BASE=$(git merge-base "$DEVELOP_BRANCH" HEAD)
417 git diff "$BASE"
Vincent Driessen5474e462010-02-04 15:50:06 +0100418 fi
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100419}
Vincent Driessenc62633f2010-02-02 10:48:50 +0100420
Vincent Driessend43ab842010-05-27 11:26:01 -0700421cmd_checkout() {
422 parse_args "$@"
423
424 if [ "$NAME" != "" ]; then
425 expand_nameprefix_arg
426 git checkout "$BRANCH"
427 else
428 die "Name a feature branch explicitly."
429 fi
430}
431
Vincent Driessena2baef92010-05-27 11:52:31 -0700432cmd_co() {
433 # Alias for checkout
434 cmd_checkout "$@"
435}
436
Vincent Driessenc62633f2010-02-02 10:48:50 +0100437cmd_rebase() {
Vincent Driessen44174922010-02-02 23:53:21 +0100438 DEFINE_boolean interactive false 'do an interactive rebase' i
Vincent Driessenc62633f2010-02-02 10:48:50 +0100439 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100440 expand_nameprefix_arg_or_current
Vincent Driessenc62633f2010-02-02 10:48:50 +0100441 warn "Will try to rebase '$NAME'..."
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100442 require_clean_working_tree
443 require_branch "$BRANCH"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100444
445 git checkout -q "$BRANCH"
Vincent Driessenf46e2902010-02-15 23:01:52 +0100446 local OPTS=
Vincent Driessen44174922010-02-02 23:53:21 +0100447 if flag interactive; then
Vincent Driessenc62633f2010-02-02 10:48:50 +0100448 OPTS="$OPTS -i"
449 fi
Vincent Driessen010252a2010-02-04 10:31:29 +0100450 git rebase $OPTS "$DEVELOP_BRANCH"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100451}
Vincent Driessenf68d4052010-07-09 12:34:18 +0200452
453avoid_accidental_cross_branch_action() {
454 local current_branch=$(git_current_branch)
455 if [ "$BRANCH" != "$current_branch" ]; then
456 warn "Trying to pull from '$BRANCH' while currently on branch '$current_branch'."
457 warn "To avoid unintended merges, git-flow aborted."
458 return 1
459 fi
460 return 0
461}
462
463cmd_pull() {
464 #DEFINE_string prefix false 'alternative remote feature branch name prefix' p
465 parse_remote_name "$@"
466
467 if [ -z "$REMOTE" ]; then
468 die "Name a remote explicitly."
469 fi
470 name_or_current
471
472 # To avoid accidentally merging different feature branches into each other,
473 # die if the current feature branch differs from the requested $NAME
474 # argument.
475 local current_branch=$(git_current_branch)
476 if startswith "$current_branch" "$PREFIX"; then
477 # we are on a local feature branch already, so $BRANCH must be equal to
478 # the current branch
479 avoid_accidental_cross_branch_action || die
480 fi
481
482 require_clean_working_tree
483
484 if git_branch_exists "$BRANCH"; then
485 # Again, avoid accidental merges
486 avoid_accidental_cross_branch_action || die
487
488 # we already have a local branch called like this, so simply pull the
489 # remote changes in
490 git pull -q "$REMOTE" "$BRANCH" || die "Failed to pull from remote '$REMOTE'."
491 echo "Pulled $REMOTE's changes into $BRANCH."
492 else
493 # setup the local branch clone for the first time
494 git fetch -q "$REMOTE" "$BRANCH" || die "Fetch failed." # stores in FETCH_HEAD
495 git branch --no-track "$BRANCH" FETCH_HEAD || die "Branch failed."
496 git checkout -q "$BRANCH" || die "Checking out new local branch failed."
497 echo "Created local branch $BRANCH based on $REMOTE's $BRANCH."
498 fi
499}